/*
 *   Copyright (c) International Business Machines  Corp., 2000
 *
 *   This program is free software;  you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY;  without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program;  if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 *
 * linux/include/linux/evms/evms_md_h.c
 *
 * EVMS MD Region Manager, User <-> Kernel common file
 *
 */

#ifndef _EVMS_MD_U_INC_
#define _EVMS_MD_U_INC_

#define EVMS_MD_ID	4
#define MD_SET_PLUGIN_ID SetPluginID(IBM_OEM_ID,EVMS_REGION_MANAGER,EVMS_MD_ID)

#define EVMS_MD_PERS_IOCTL_CMD 	1	/* personality specific ioctl command */
#define EVMS_MD_ADD		2
#define EVMS_MD_REMOVE		3
#define EVMS_MD_ACTIVATE	4
#define EVMS_MD_DEACTIVATE	5
#define EVMS_MD_GET_ARRAY_INFO  6

/* structure definition to use with MD_ADD, MD_REMOVE, MD_ACTIVATE */
typedef struct evms_md_kdev_s {
	u_int32_t major;		/* 1 Device major number */
	u_int32_t minor;		/* 2 Device minor number */
} evms_md_kdev_t;

/* structure definition to use with MD_GET_ARRAY_INFO */
#define EVMS_MD_ARRAY_DEGRADED  (1<<0)
#define EVMS_MD_ARRAY_SYNCING   (1<<1)
typedef struct evms_md_array_info_s {
        unsigned long   state;	/* degraded mode, syncing,...*/
        mdp_super_t     *sb;	/* array super block */
} evms_md_array_info_t;

typedef struct evms_md_ioctl_s {
	int	mddev_idx;	/* same as __minor in mddev_s struct */
	int 	cmd;		/* Command for personality */
	void	*arg;		/* Command specific ioctl command structure */
} evms_md_ioctl_t;

/* Needed by mddev_s structure in evms_md_k.h */
typedef struct mdu_param_s
{
	int			personality;	/* 1,2,3,4 */
	int			chunk_size;	/* in bytes */
	int			max_fault;	/* unused for now */
} mdu_param_t;


#endif

